<?php
/**
 * Shortcodes
 */

defined( 'ABSPATH' ) || exit;

/**
 * MWPS Shortcodes class.
 */
class MLTS_Shortcodes {
    /**
     * Init shortcodes.
     */
    public static function init() {
        $shortcodes = array(
            'medic52_lift_trail_status'     => __CLASS__ . '::medic52_lift_trail_status',
        );

        foreach ( $shortcodes as $shortcode => $function ) {
            add_shortcode( apply_filters( "{$shortcode}_shortcode_tag", $shortcode ), $function );
        }
    }

    /**
     * Shortcode Wrapper.
     *
     * @param string[] $function Callback function.
     * @param array    $atts     Attributes. Default to empty array.
     * @param array    $wrapper  Customer wrapper data.
     *
     * @return string
     */
    public static function shortcode_wrapper(
        $function,
        $atts = array(),
        $wrapper = array(
            'class'  => 'mwpstatus',
            'before' => null,
            'after'  => null,
        )
    ) {
        ob_start();

        // @codingStandardsIgnoreStart
        echo empty( $wrapper['before'] ) ? '<div class="' . esc_attr( $wrapper['class'] ) . '">' : $wrapper['before'];
        call_user_func( $function, $atts );
        echo empty( $wrapper['after'] ) ? '</div>' : $wrapper['after'];
        // @codingStandardsIgnoreEnd

        return ob_get_clean();
    }

    /**
     * medic52_lift_trail_status page shortcode.
     *
     * @param array $atts Attributes.
     * @return string
     */
    public static function medic52_lift_trail_status( $atts ) {
        return self::shortcode_wrapper( array( 'MLTS_Shortcode_Lift_Trail', 'output' ), $atts );
    }
}